﻿Option Strict Off
Imports System
Imports System.Collections
Imports NXOpen
Imports NXOpenUI
Imports NXOpen.Utilities
Imports NXOpen.UF
Imports NXOpen.Features

Module FeatureSuppression
    Dim s As Session = Session.GetSession()
    Dim ui As UI = UI.GetUI()
    Dim ufs As UFSession = UFSession.GetUFSession()
    Dim lw As ListingWindow = s.ListingWindow
    Dim workPart As Part = s.Parts.Work

    Sub Main()
        Dim markId1 As Session.UndoMarkId
        Dim requiredexps As ArrayList = New ArrayList
        ' check the workpart for a suppression expression
        lw.Open()
        Dim allexpressions As ExpressionCollection = workPart.Expressions
        For Each e1 As Expression In allexpressions
            ' list the suppression expressions
            If e1.Description.Contains("Suppression") Then
                lw.WriteLine(e1.Equation.ToString & "  " & e1.Description)
                ' save the suppression expressions
                requiredexps.Add(e1)
            End If
        Next
        ' As an example suppress all blocks
        For Each e1 As Expression In requiredexps
            If e1.Description.Contains("block") Then
                e1.RightHandSide = 0
            End If
        Next
        Dim nErrs1 As Integer
        nErrs1 = s.UpdateManager.DoUpdate(markId1)
    End Sub

    Public Function GetUnloadOption(ByVal dummy As String) As Integer
        'Unloads the image immediately after execution within NX
        GetUnloadOption = NXOpen.Session.LibraryUnloadOption.Immediately
    End Function

End Module
